﻿Imports System.Runtime.InteropServices
Imports System.Text


Module PaltalkModule
    Structure RECT
        Public Left As Int32
        Public Top As Int32
        Public Right As Int32
        Public Bottom As Int32
    End Structure


    'Public Declare Function IsWindowVisible Lib "user32" (ByVal hwnd As Integer) As Integer
    <DllImport("user32.dll", SetLastError:=True)>
    Private Function IsWindowVisible(ByVal hWnd As IntPtr) As <MarshalAs(UnmanagedType.Bool)> Boolean
    End Function
    <DllImport("user32.dll", SetLastError:=True)>
    Private Function FindWindow(lpClassName As String, lpWindowName As String) As IntPtr
    End Function
    <DllImport("user32.dll", CharSet:=CharSet.Auto)>
    Public Function SendMessage(ByVal hWnd As IntPtr, ByVal Msg As Integer, ByVal wParam As IntPtr, <MarshalAs(UnmanagedType.LPWStr)> ByVal lParam As String) As IntPtr
    End Function
    <DllImport("user32.dll", CharSet:=CharSet.Auto)>
    Public Function SendMessage(ByVal hWnd As IntPtr, ByVal Msg As Integer, ByVal wParam As Integer, <MarshalAs(UnmanagedType.LPWStr)> ByVal lParam As String) As IntPtr
    End Function
    <DllImport("user32.dll", CharSet:=CharSet.Auto)>
    Public Function SendMessage(ByVal hWnd As IntPtr, ByVal Msg As Integer, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As IntPtr
    End Function
    Public Delegate Function EnumCallBackDelegate(ByVal hwnd As IntPtr, ByVal lParam As Integer) As Boolean
    Public Declare Function EnumChildWindows Lib "user32" (ByVal hWndParent As Integer, ByVal lpEnumFunc As EnumCallBackDelegate, ByVal lParam As Integer) As Boolean
    Public Declare Function IsWindow Lib "user32" (ByVal hwnd As Integer) As Boolean
    Private Const EM_GETLINECOUNT As Integer = &HBA
    Private Const EM_GETLINE As Integer = &HC4
    Public Const WM_GETTEXTLENGTH As Integer = &HE
    Public Const WM_LBUTTONDOWN As Integer = &H201
    Public Const WM_LBUTTONUP As Integer = &H202
    Public Const WM_SETTEXT As Integer = &HC
    Private Const EM_LINELENGTH As Integer = &HC1
    Public Const WM_GETTEXT As Integer = &HD
    Private Const HTCAPTION As Short = 2
    Private Const WM_KEYDOWN As Integer = &H100
    Const WM_USER = &H400
    Const EM_LINEINDEX = &HBB
    Const EM_EXLINEFROMCHAR = (WM_USER + 54)
    Private Const EM_EXSETSEL As Integer = (WM_USER + 55)
    Private Const EM_GETCHARFORMAT As Integer = (WM_USER + 58)


    Public Const GW_Child As Integer = 5
    Private Const GW_HWNDNEXT As Short = 2

    '4 vars holding the panes found
    Public palTypeinPaneVar As IntPtr = 0    'typein pane for palChatroom
    Public palComboVar As IntPtr = 0 'has room name in it
    Public palTypeinButtonVar As IntPtr = 0
    Public palChatroomVar As IntPtr = 0     'palChatroom being looked at
    Private MaxStringLength As Integer = 255
    Public FoundWindow As IntPtr
    Public LastLineCharIndex As Integer = 9999999   'character position of last line
    Private ChatWindowClass As StringBuilder = New StringBuilder(MaxStringLength)


    Dim PaltalkWindow As String = "Paltalk ReadRoom"
    <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Private Function PostMessage(ByVal hWnd As IntPtr, ByVal Msg As UInteger, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As Boolean
    End Function

    Private Const WM_CHAR As Integer = &H102
    Private Const VK_RETURN As Integer = &HD
    Sub PrintInRoom(ByVal str As String)
        If Not IsWindow(palTypeinPaneVar) Then
            Exit Sub
        End If
        SendMessage(palTypeinPaneVar, WM_SETTEXT, 0, str)
        'SendMessage(palTypeinPaneVar, WM_CHAR, New IntPtr(VK_RETURN), IntPtr.Zero)
        SendMessage(palTypeinPaneVar, WM_KEYDOWN, New IntPtr(13), IntPtr.Zero)
    End Sub


    'This function finds all the needed chat window/child window handles and returns true if all were found.
    Public Function findAllWindowHndls() As Boolean
        Dim hwnd As IntPtr
        hwnd = FindWindow(Nothing, PaltalkWindow) 'find Read Room
        If IsWindow(hwnd) Then
            findPalControls(hwnd)
        End If
        If IsWindow(hwnd) And IsWindow(palTypeinPaneVar) Then
            findAllWindowHndls = True
        Else
            findAllWindowHndls = False
        End If
    End Function

    Public Function ReadRoomHandle() As IntPtr
        If IsWindow(palChatroomVar) Then
            Return (palChatroomVar)
        Else
            findAllWindowHndls()
            'palChatroomVar = FindWindow(vbNullString, "ReadRoom") 'Nothing
            Return (palChatroomVar)
        End If
    End Function

    Public Function checkInRoom() As Boolean
        If IsWindow(palChatroomVar) AndAlso IsWindow(palTypeinPaneVar) Then
            checkInRoom = True
        Else
            palChatroomVar = ReadRoomHandle()
            checkInRoom = False
            If IsWindow(palChatroomVar) Then
                'Sleep(1000)
                'hwnd = palTypeinPane(hwnd)
                findPalControls(palChatroomVar)
                If IsWindow(palChatroomVar) And IsWindow(palTypeinPaneVar) Then
                    checkInRoom = True
                    LastLineCharIndex = LastCharIndex(palChatroomVar)
                Else
                    checkInRoom = False
                End If
            End If
        End If
    End Function


    ' last_char_index
    ' parameters:
    ' in: richedit control HWND
    ' returns: index of last (empty) line
    Function LastCharIndex(ByVal rich20 As IntPtr) As Integer
        Dim index, Lines As Integer
        If IsWindow(rich20) = 0 Then
            ' invalid window handle
            ResetLastLineCounter() 'LastCharIndex = -1
            Exit Function
        End If
        Lines = SendMessage(rich20, EM_GETLINECOUNT, IntPtr.Zero, IntPtr.Zero)
        index = SendMessage(rich20, EM_LINEINDEX, New IntPtr(Lines - 2), IntPtr.Zero) 'last line in window is always empty, and since it is 0 based it is count - 2
        LastCharIndex = index
    End Function
    Public MaxIndexValue As Integer = 9999999
    Public Sub ResetLastLineCounter()
        LastLineCharIndex = MaxIndexValue
    End Sub
    Public Sub ResetLastLineCounter2LastLine(ByVal rich20 As IntPtr)
        If IsWindow(rich20) Then
            LastLineCharIndex = LastCharIndex(rich20)
        End If
    End Sub

    ' get_next_line
    ' parameters:
    ' in: richedit control HWND
    ' in/out: bext index to get line from
    ' out: buffer for line text out
    ' in: buffer size
    ' returns: true text retrived, false otherwise
    Private Const SCF_SELECTION As Integer = 1

    Declare Auto Function SendMessage Lib "USER32" (ByVal hwnd As IntPtr, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As Byte()) As Integer
    Dim LastNicSeen As String = "Nobody"
    'A new line is either a header (no previous line contents and a time stamp). set previous
    'or content (previous line contents). clear previous, and return previous with current.
    'System information (content without previous line contents). return but ignore.
    'From Classic: ChicagoDavid52: This is a test
    Public Function GetNextLine(ByRef retstr As String) As Boolean
        Dim iRetval As Integer
        Dim baText() As Byte
        Dim MaxBuffer As Integer = 500
        Dim index
        Dim line As Integer
        Dim hwnd As IntPtr
        If Not checkInRoom() Then
            Return (False)
        End If
        hwnd = palChatroomVar
        ' last line char index
        index = LastCharIndex(hwnd)
        ' check if text was cleared or haven't changed
        If (index <= LastLineCharIndex) Then
            If (index < LastLineCharIndex) Then
                ' text was cleared
                LastLineCharIndex = index
            End If
            GetNextLine = False
            Exit Function
        End If

        ' Cap MaxBuffer so it can never be too large
        If MaxBuffer > 65535 Then MaxBuffer = 65535
        ' Set byte array to max buffer size (times 2 for Wide) + 1
        ReDim baText((MaxBuffer * 2) + 1)
        ' Get bytes for max buffer size
        Dim bSize() As Byte
        bSize = BitConverter.GetBytes(MaxBuffer)
        '  Write max buffer size as WORD to begining of baText array
        baText(0) = bSize(0)
        baText(1) = bSize(1)

        line = SendMessage(hwnd, EM_EXLINEFROMCHAR, IntPtr.Zero, New IntPtr(LastLineCharIndex))

        ' Get Line data (iRetval = number of characters in line)
        iRetval = SendMessage(hwnd, EM_GETLINE, line + 1, baText)

        If (iRetval > 0) Then
            retstr = System.Text.Encoding.Unicode.GetString(baText).Substring(0, iRetval)
            LastLineCharIndex = SendMessage(hwnd, EM_LINEINDEX, New IntPtr(line + 1), IntPtr.Zero)
            If retstr = "" Then
                Return False 'the first of two lines was set, so exit without a read.
            End If
            GetNextLine = True
        Else
            retstr = ""
            LastLineCharIndex = PostMessage(hwnd, EM_LINEINDEX, line + 1, 0)
            GetNextLine = False
        End If

    End Function
    <DllImport("user32.dll", CharSet:=CharSet.Auto)>
    Private Function GetClassName(ByVal hWnd As System.IntPtr,
   ByVal lpClassName As System.Text.StringBuilder,
   ByVal nMaxCount As Integer) As Integer
        ' Leave function empty    
    End Function
    <DllImport("user32.dll")>
    Private Function GetWindowRect(ByVal hWnd As IntPtr, ByRef lpRect As RECT) As Boolean
    End Function

    Public Function findPalControlsproc(ByVal hwnd As IntPtr, ByVal lParam As Integer) As Boolean
        Dim WinRect As RECT
        Dim Height As Integer
        Dim Width As Integer
        GetClassName(hwnd, ChatWindowClass, MaxStringLength)
        GetWindowRect(hwnd, WinRect)
        Height = WinRect.Bottom - WinRect.Top
        Width = WinRect.Right - WinRect.Left
        If Height < 100 AndAlso Width > 500 AndAlso InStr(ChatWindowClass.ToString, "EDIT") <> 0 Then
            palTypeinPaneVar = hwnd 'typein
        ElseIf Height > 150 AndAlso Width > 500 AndAlso InStr(ChatWindowClass.ToString, "RICHEDIT") <> 0 Then 'assume room window is high
            palChatroomVar = hwnd
        ElseIf InStr(ChatWindowClass.ToString, "COMBO") <> 0 Then
            palComboVar = hwnd
        End If
        findPalControlsproc = True 'continue
    End Function

    Public Sub findPalControls(ByVal hwnd As IntPtr)
        EnumChildWindows(hwnd, AddressOf findPalControlsproc, 0)
    End Sub

End Module
